=== debian/changelog ===
netcdf-fortran (4.5.2+ds-1build2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:08:18 +0100

netcdf-fortran (4.5.2+ds-1build1) focal; urgency=medium

  * No-change upload for netcdf soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 30 Jan 2020 18:04:21 +0100

netcdf-fortran (4.5.2+ds-1) unstable; urgency=medium

  * Bump Standards-Version to 4.4.1, no changes.
  * Drop Name field from upstream metadata.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 23 Jan 2020 05:38:53 +0100

netcdf-fortran (4.5.2+ds-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 19 Sep 2019 07:09:46 +0200

netcdf-fortran (4.5.1+ds-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 05 Sep 2019 06:03:45 +0200

netcdf-fortran (4.5.0+ds-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Add fortran-compiler as alternative build dependency.
    (closes: #922645)
  * Update gbp.conf to use --source-only-changes by default.
  * Bump Standards-Version to 4.4.0, no changes.
  * Update copyright file, changes:
    - Update copyright years for UCAR
    - Drop license & copyright for removed files
  * Rename library package for SONAME bump.
  * Refresh patches.
  * Update symbols for 4.5.0.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 30 Aug 2019 07:54:45 +0200
