## netcdf-fortran 4.5.3+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -17,7 +17,7 @@
 #Project Version
 SET(NC4F_VERSION_MAJOR 4)
 SET(NC4F_VERSION_MINOR 5)
-SET(NC4F_VERSION_PATCH 2)
+SET(NC4F_VERSION_PATCH 3)
 SET(NC4F_VERSION_NOTE "")
 SET(NC4F_VERSION ${NC4F_VERSION_MAJOR}.${NC4F_VERSION_MINOR}.${NC4F_VERSION_PATCH}${NC4F_VERSION_NOTE})
 SET(VERSION ${NC4F_VERSION})
@@ -88,6 +88,12 @@
 # For CMAKE_INSTALL_LIBDIR
 INCLUDE(GNUInstallDirs)
 
+# Include this so we can check values in netcdf_meta.h.
+INCLUDE(CheckCSourceCompiles)
+
+# By default install Fortran modules into include directory
+SET(Fortran_INSTALL_MODDIR "${CMAKE_INSTALL_INCLUDEDIR}" CACHE STRING "Fortran module install directory")
+
 IF(MSVC)
   SET(GLOBAL PROPERTY USE_FOLDERS ON)
 ENDIF()
@@ -101,6 +107,8 @@
 INCLUDE (TestBigEndian)
 INCLUDE (CheckSymbolExists)
 INCLUDE (GetPrerequisites)
+INCLUDE (CheckFortranSourceCompiles)
+INCLUDE (CheckFortranCompilerFlag)
 FIND_PACKAGE(PkgConfig QUIET)
 
 # Enable 'dist and distcheck'.
@@ -354,6 +362,38 @@
 
 ENDMACRO()
 
+# A function used to create autotools-style 'yes/no' definitions.
+# If a variable is set, it 'yes' is returned. Otherwise, 'no' is
+# returned.
+#
+# Also creates a version of the ret_val prepended with 'NC',
+# when feature is true, which is used to generate netcdf_meta.h.
+FUNCTION(is_enabled feature ret_val)
+  IF(${feature})
+    SET(${ret_val} "yes" PARENT_SCOPE)
+    SET("NC_${ret_val}" 1 PARENT_SCOPE)
+  ELSE()
+    SET(${ret_val} "no" PARENT_SCOPE)
+    SET("NC_${ret_val}" 0 PARENT_SCOPE)
+  ENDIF(${feature})
+ENDFUNCTION()
+
+# A function used to create autotools-style 'yes/no' definitions.
+# If a variable is set, it 'yes' is returned. Otherwise, 'no' is
+# returned.
+#
+# Also creates a version of the ret_val prepended with 'NC',
+# when feature is true, which is used to generate netcdf_meta.h.
+FUNCTION(is_disabled feature ret_val)
+  IF(${feature})
+    SET(${ret_val} "no" PARENT_SCOPE)
+  ELSE()
+    SET(${ret_val} "yes" PARENT_SCOPE)
+    SET("NC_${ret_val}" 1 PARENT_SCOPE)
+  ENDIF(${feature})
+ENDFUNCTION()
+
+
 ################################
 # End Macro Definitions
 ################################
@@ -379,48 +419,3 @@
 
   ADD_TEST(${prefix}_${F} bash "-c" "TOPSRCDIR=${CMAKE_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}/${prefix}_${F}")
   IF(MSVC)
-    SET_PROPERTY(TARGET ${prefix}_${F} PROPERTY FOLDER "tests")
-  ENDIF()
-ENDMACRO()
-
-# Build a binary used by a script, but don't make a test out of it.
-MACRO(build_bin_test F ext)
-  ADD_EXECUTABLE(${F} ${F}${ext})
-  TARGET_LINK_LIBRARIES(${F} netcdff ${NETCDF_C_LIBRARY})
-  IF(MSVC)
-    SET_TARGET_PROPERTIES(${F}
-      PROPERTIES LINK_FLAGS_DEBUG " /NODEFAULTLIB:MSVCRT"
-      )
-  ENDIF()
-ENDMACRO()
-
-OPTION(ENABLE_LARGE_FILE_TESTS "Run large file tests, which are slow and take lots of disk." OFF)
-SET(LARGE_FILE_TESTS ${ENABLE_LARGE_FILE_TESTS})
-OPTION(BUILD_BENCHMARKS "Run F90 I/O Benchmarks" OFF)
-OPTION(TEST_WITH_VALGRIND "Run extra tests with valgrind" OFF)
-OPTION(ENABLE_PARALLEL_TESTS "Run parallel I/O tests for F90 and F77" OFF)
-
-SET(TEST_PARALLEL OFF)
-IF(ENABLE_PARALLEL_TESTS)
-  SET(TEST_PARALLEL ON)
-ENDIF()
-
-###
-# Seek out netcdf library file and include path.
-###
-
-IF(NOT NETCDF_C_LIBRARY)
-  FIND_LIBRARY(NETCDF_C_LIBRARY NAMES netcdf)
-  IF(NOT NETCDF_C_LIBRARY)
-    MESSAGE(FATAL_ERROR "libnetcdf not found.")
-  ENDIF()
-ENDIF()
-MESSAGE(STATUS "Found netcdf library: ${NETCDF_C_LIBRARY}")
-
-IF(NOT NETCDF_INCLUDE_DIR)
-  FIND_PATH(NETCDF_INCLUDE_DIR NAMES netcdf.h)
-  IF(NOT NETCDF_INCLUDE_DIR)
-    MESSAGE(FATAL_ERROR "netcdf.h not found.")
-  ENDIF()
-ENDIF()
-MESSAGE(STATUS "Found netcdf.h in ${NETCDF_INCLUDE_DIR}")
