=== nf03_test4/CMakeLists.txt ===
--- 
+++ 
@@ -64,25 +64,6 @@
   ENDIF(BUILD_BENCHMARKS)
 endif(USE_NETCDF4)
 
-FIND_LIBRARY(NETCDF_C_LIBRARY NAMES netcdf libnetcdf)
-FIND_PATH(NETCDF_C_INCLUDE_DIR netcdf.h)
-IF(NOT NETCDF_C_LIBRARY)
-  MESSAGE(FATAL_ERROR "Cannot find netCDF C library, needed for netCDF Fortran tests.")
-ENDIF()
-
-INCLUDE_DIRECTORIES(BEFORE
-  ${CMAKE_CURRENT_BINARY_DIR}
-  ${CMAKE_BINARY_DIR}/fortran
-  ${CMAKE_SOURCE_DIR}
-  ${CMAKE_SOURCE_DIR}/fortran)
-
-INCLUDE_DIRECTORIES(
-  ${CMAKE_CPP_FLAGS}
-  ${NETCDF_C_INCLUDE_DIR})
-
-LINK_DIRECTORIES(${CMAKE_SOURCE_DIR}/fortran
-  ${NC4F_BINARY_DIR}/fortran)
-
 # Create pre-compiled tests.
 FOREACH(t ${TESTS})
   ADD_EXECUTABLE(${t} ${${t}_SOURCES})
