=== nf_test/CMakeLists.txt ===
--- 
+++ 
@@ -39,21 +39,6 @@
 execute_process(COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/ref_fills.nc
   ${CMAKE_CURRENT_BINARY_DIR}/fills.nc)
 
-INCLUDE_DIRECTORIES(BEFORE
-  ${CMAKE_CURRENT_BINARY_DIR}
-  ${CMAKE_BINARY_DIR}/fortran
-  ${CMAKE_BINARY_DIR}/libsrc
-  ${CMAKE_SOURCE_DIR}
-  ${CMAKE_SOURCE_DIR}/fortran
-  ${CMAKE_SOURCE_DIR}/libsrc)
-
-INCLUDE_DIRECTORIES(
-  ${CMAKE_CPP_FLAGS}
-  ${NETCDF_C_INCLUDE_DIR})
-
-LINK_DIRECTORIES(${CMAKE_SOURCE_DIR}/fortran ${CMAKE_SOURCE_DIR}/libsrc
-  ${NC4F_BINARY_DIR}/fortran)
-
 # Create pre-compiled tests.
 FOREACH(t ${TESTS})
   ADD_EXECUTABLE(${t} ${${t}_SOURCES})
