=== debian/changelog ===
netcdf-fortran (4.5.3+ds-2) unstable; urgency=medium

  * Update reproducible-settings.patch with changes by Chris Lamb.
    (closes: #962401)
  * Bump watch file version to 4.
  * Update lintian overrides.
  * Mark reproducible-settings.patch as Forwarded: not-needed.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 12 Nov 2020 05:10:00 +0100

netcdf-fortran (4.5.3+ds-1) unstable; urgency=medium

  * New upstream release.
    (closes: #957593)
  * Bump Standards-Version to 4.5.0, no changes.
  * Bump debhelper compat to 10, changes:
    - Drop --parallel option, enabled by default
    - Don't explicitly enable autoreconf, enabled by default
    - Drop dh-autoreconf build dependency
  * Add patch to make settings file reproducible.
  * Include netcdff.settings in libnetcdff-dev.
  * Update symbols for 4.5.3.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 03 Jun 2020 06:09:02 +0200
