=== debian/control ===
--- 
+++ 
@@ -2,18 +2,16 @@
 Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
 Uploaders: Francesco Paolo Lovergine <frankie@debian.org>,
            Nico Schlömer <nico.schloemer@gmail.com>,
-           Ross Gammon <rossgammon@mail.dk>,
            Bas Couwenberg <sebastic@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9.20160114),
-               dh-autoreconf,
+Build-Depends: debhelper (>= 10~),
                gfortran | fortran-compiler,
                doxygen,
                graphviz,
                libnetcdf-dev (>= 1:4.6.2),
                pkg-config
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/netcdf-fortran
 Vcs-Git: https://salsa.debian.org/debian-gis-team/netcdf-fortran.git
 Homepage: http://www.unidata.ucar.edu/software/netcdf/
